﻿Type=Service
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public wifiManager As WiFiConnect
	Public astream As AsyncStreams
	Public socket As Socket
	Private bc As ByteConverter
	Private watchdog As Timer
	Private Port(2) As Int
	Private connection As Int
	Private WeMosIp As String = "192.168.4.1"
	Private confirmation As Boolean
End Sub

Sub Service_Create
	bc.LittleEndian = True
	
	connection = 0
	Port(0) = 51041
	Port(1) = 51042

	confirmation = False

	wifiManager.Initialize

'	socket.Initialize("socket")
'	socket.Connect(WeMosIp, Port(0), 30000)

	watchdog.Initialize("watchdog", 1000)
	watchdog.Enabled = True
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Private Sub Socket_Connected (Successful As Boolean)
	Log("Successful=" & Successful)
	If Successful Then
		astream.Initialize(socket.InputStream, socket.OutputStream, "astream")
	End If
End Sub

Private Sub watchdog_Tick
	Dim ip As String = wifiManager.getIpAddress
	Log("ip=" & ip)
	If ip.StartsWith("192.168.4") And Not(confirmation) Then
		If ip.EndsWith(".2") Then
			connection = 0
		Else
			connection = 1
		End If
		socket.Initialize("socket")
		socket.Connect(WeMosIp, Port(connection), 30000)
	End If
	If confirmation Then
		CallSub2(Main, "StateChanged", True)
	Else 
		CallSub2(Main, "StateChanged", False)
	End If
End Sub

Private Sub Astream_NewData (Buffer() As Byte)
	Dim key As String = bc.StringFromBytes(Buffer, "UTF8")
	Log("Astream_NewData= " & key)

	If key = "OK" Then
		confirmation = True
	End If
		
	If key = "R1" Then
		CallSub2(Main, "WeMosLedRed", True)
	Else if key = "R0" Then
		CallSub2(Main, "WeMosLedRed", False)
	End If
	
	If key = "Y1" Then
		CallSub2(Main, "WeMosLedYellow", True)
	Else if key = "Y0" Then
		CallSub2(Main, "WeMosLedYellow", False)
	End If
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
